#!/usr/bin/env ruby

gem 'rb-fsevent', '0.9.4'
require 'rb-fsevent'

class Vader
  autoload :VERSION, 'vader/version'
  autoload :Exec,    'vader/exec'
  autoload :Init,    'vader/init'
  autoload :Setup,   'vader/setup'
  autoload :Sync,    'vader/sync'
  autoload :Up,      'vader/up'

  autoload :DockerUtil, 'vader/docker_util'

  COMMANDS = {
    'exec'  => -> { Vader::Exec },
    'init'  => -> { Vader::Init }, #TODO
    'setup' => -> { Vader::Setup },
    'sync'  => -> { Vader::Sync },
    'up'    => -> { Vader::Up }
  }

  def run
    check_version

    command = ARGV.shift

    if COMMANDS.key?(command)
      COMMANDS[command].call.new.run
    else
      # TODO: Print help
    end
  end

  private
  def check_version
    unless 'darwin' == Gem::Platform.local.os
      $stderr.puts "Error: vader only supports OS X"
      exit 1
    end
  end
end
